/*

  Author(s): Ilja V. Ryndin (ryndin@pinebrush.com)

  Start date: *

*/

#ifndef PARSECQT5PLUGIN_H
#define PARSECQT5PLUGIN_H

#include "parsec_common_qt5_global.h"

#include <QtCore>

namespace ParsecQt5
{
    class PARSEC_COMMON_QT5_EXPORT Plugin
    {
    public:

        enum Type { Undefined = 0, DesktopIntegration = 1 };

        Plugin();
        virtual ~Plugin();

    private:

        friend class PluginHandle;
    };

    typedef QList<Plugin *> PluginPtrList;
    typedef Plugin::Type( *typedef_PluginTypeFunc )();
    typedef Plugin *( *typedef_PluginInstanceFunc )();
}

#endif // PARSECQT5PLUGIN_H
