#ifndef PARSECQT5ICONPROVIDER_H
#define PARSECQT5ICONPROVIDER_H

#include "parsec_common_qt5_global.h"

#include <QIcon>

#define PARSECQT5_NEW_ACTION_ICON_ID		1000
#define PARSECQT5_BLANK_ACTION_ICON_ID		1001
#define PARSECQT5_OPEN_ACTION_ICON_ID		1002
#define PARSECQT5_FILE_ICON_ID			1003
#define PARSECQT5_SAVE_ACTION_ICON_ID		1004
#define PARSECQT5_CLOSE_ICON_ID			1005
#define PARSECQT5_COPY_ICON_ID			1006
#define PARSECQT5_PASTE_ICON_ID			1007
#define PARSECQT5_REMOVE_ICON_ID		1008
#define PARSECQT5_EXIT_ICON_ID			1009
#define PARSECQT5_HELP_ICON_ID			1010
#define PARSECQT5_PRINT_ACTION_ICON_ID		1011
#define PARSECQT5_EXPORT_ACTION_ICON_ID		1012
#define PARSECQT5_ABOUT_ACTION_ICON_ID		1013
#define PARSECQT5_HELP_ACTION_ICON_ID		1014
#define PARSECQT5_CANCEL_ACTION_ICON_ID		1015
#define PARSECQT5_USER_ICON_ID			1016
#define PARSECQT5_GROUP_ICON_ID			1017
#define PARSECQT5_KEY_ICON_ID			1018
#define PARSECQT5_REPORT_ICON_ID		1019
#define PARSECQT5_UNKNOWN_ICON_ID		1020
#define PARSECQT5_PLUS_ICON_ID			1021
#define PARSECQT5_MINUS_ICON_ID			1022
#define PARSECQT5_CONNECT_ICON_ID		1023
#define PARSECQT5_DISCONNECT_ICON_ID		1024
#define PARSECQT5_GEARS_ICON_ID			1025
#define PARSECQT5_REFRESH_ICON_ID		1026
#define PARSECQT5_LIST_ICON_ID			1027

namespace ParsecQt5
{
    class PARSEC_COMMON_QT5_EXPORT IconProvider
    {
    public:
         IconProvider();
         ~IconProvider();

         virtual QIcon iconById( int id ) = 0;
         QIcon mergedIconByIds( int frontIconId, int backIconId );
    };
}

#endif // PARSECQT5ICONPROVIDER_H
